Main Page Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members

# TAO_PrincipalAuthenticator Class Reference

Implementation of the SecurityLevel2::PrincipalAuthenticator interface. More...

`#include <PrincipalAuthenticator.h>`

Inheritance diagram for TAO_PrincipalAuthenticator:

[legend]
Collaboration diagram for TAO_PrincipalAuthenticator:

[legend]
List of all members.

## Downcast Related Methods
Methods used for downcasting and manipulating the reference count of this interface.
typedef TAO_PrincipalAuthenticator_ptr | _ptr_type
typedef TAO_PrincipalAuthenticator_var | _var_type
virtual void * | _tao_QueryInterface (ptr_arith_t type)
virtual const char * | _interface_repository_id (void) const
TAO_PrincipalAuthenticator_ptr | _duplicate (TAO_PrincipalAuthenticator_ptr obj)
TAO_PrincipalAuthenticator_ptr | _narrow (CORBA::Object_ptr obj ACE_ENV_ARG_DECL_WITH_DEFAULTS)
TAO_PrincipalAuthenticator_ptr | _unchecked_narrow (CORBA::Object_ptr obj ACE_ENV_ARG_DECL_WITH_DEFAULTS)
TAO_PrincipalAuthenticator_ptr | _nil (void)
int | _tao_class_id = 0
## Public Methods
| TAO_PrincipalAuthenticator (TAO_SecurityManager *manager)
| Constructor. More...
void | register_vault (SecurityReplaceable::Vault_ptr vault ACE_ENV_ARG_DECL_WITH_DEFAULTS)
SecurityLevel2::PrincipalAuthenticator Methods
Methods exposed by the SecurityLevel2::PrincipalAuthenticator interface.
virtual Security::AuthenticationMethodList * | get_supported_authen_methods (const char *mechanism ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
| Return the authentication methods supported by the given mechanism. More...
virtual Security::AuthenticationStatus | authenticate (Security::AuthenticationMethod method, const char *mechanism, const char *security_name, const CORBA::Any &auth_data, const Security::AttributeList &privileges, SecurityLevel2::Credentials_out creds, CORBA::Any_out continuation_data, CORBA::Any_out auth_specific_data ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
| Created Credentials will be placed in the SecurityManager object's own_credentials list. More...
virtual Security::AuthenticationStatus | continue_authentication (const CORBA::Any &response_data, SecurityLevel2::Credentials_ptr creds, CORBA::Any_out continuation_data, CORBA::Any_out auth_specific_data ACE_ENV_ARG_DECL_WITH_DEFAULTS) throw (CORBA::SystemException)
| Continue partially completed authentication process. More...
## Protected Methods
| ~TAO_PrincipalAuthenticator (void)
| Protected destructor to enforce the fact this class is reference counted, and should not be destroyed using delete() by anything other than the reference counting mechanism. More...
## Private Attributes
ACE_Array_Base< void *> | vaults_
| Array of registered security mechanism-specific Vaults. More...
TAO_SecurityManager * | security_manager_
| Pointer to the SecurityManager that "owns" this PrincipalAuthenticator. More...

## Detailed Description

Implementation of the SecurityLevel2::PrincipalAuthenticator interface.

This class implements the chain-of-responsibility design pattern to decide which security mechanism

## Member Typedef Documentation

typedef TAO_PrincipalAuthenticator_ptr TAO_PrincipalAuthenticator::_ptr_type

| Reimplemented from CORBA_LocalObject.

typedef TAO_PrincipalAuthenticator_var TAO_PrincipalAuthenticator::_var_type

| Reimplemented from CORBA_LocalObject.

## Constructor & Destructor Documentation

TAO_PrincipalAuthenticator::TAO_PrincipalAuthenticator | ( | TAO_SecurityManager * | manager | ) |

| Constructor.

TAO_PrincipalAuthenticator::~TAO_PrincipalAuthenticator | ( | void |  | ) | `[protected]`

| Protected destructor to enforce the fact this class is reference counted, and should not be destroyed using delete() by anything other than the reference counting mechanism.

## Member Function Documentation

TAO_PrincipalAuthenticator_ptr TAO_PrincipalAuthenticator::_duplicate | ( | TAO_PrincipalAuthenticator_ptr | obj | ) | `[static]`

virtual const char* TAO_PrincipalAuthenticator::_interface_repository_id | ( | void |  | ) | const`[virtual]`

| Reimplemented from CORBA_Object.

TAO_PrincipalAuthenticator_ptr TAO_PrincipalAuthenticator::_narrow | ( | CORBA::Object_ptr obj | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | `[static]`

| Reimplemented from CORBA_LocalObject.

TAO_PrincipalAuthenticator_ptr TAO_PrincipalAuthenticator::_nil | ( | void |  | ) | `[inline, static]`

| Reimplemented from CORBA_LocalObject.

virtual void* TAO_PrincipalAuthenticator::_tao_QueryInterface | ( | ptr_arith_t | type | ) | `[virtual]`

| Reimplemented from CORBA_Object.

TAO_PrincipalAuthenticator_ptr TAO_PrincipalAuthenticator::_unchecked_narrow | ( | CORBA::Object_ptr obj | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | `[static]`

| Reimplemented from CORBA_LocalObject.

Security::AuthenticationStatus TAO_PrincipalAuthenticator::authenticate | ( | Security::AuthenticationMethod | method,
|  | const char * | mechanism,
|  | const char * | security_name,
|  | const CORBA::Any & | auth_data,
|  | const Security::AttributeList & | privileges,
|  | SecurityLevel2::Credentials_out | creds,
|  | CORBA::Any_out | continuation_data,
|  | CORBA::Any_out auth_specific_data | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)`[virtual]`

| Created Credentials will be placed in the SecurityManager object's own_credentials list. If authenticate() returns with a Security::SecAuthContinue, e.g. due to an inability to complete authentication in a single operation, then authentication must completed using the continue_authentication() method.

Security::AuthenticationStatus TAO_PrincipalAuthenticator::continue_authentication | ( | const CORBA::Any & | response_data,
|  | SecurityLevel2::Credentials_ptr | creds,
|  | CORBA::Any_out | continuation_data,
|  | CORBA::Any_out auth_specific_data | ACE_ENV_ARG_DECL
| ) | throw (CORBA::SystemException)`[virtual]`

| Continue partially completed authentication process.

virtual Security::AuthenticationMethodList* TAO_PrincipalAuthenticator::get_supported_authen_methods | ( | const char *mechanism | ACE_ENV_ARG_DECL_WITH_DEFAULTS | ) | throw (CORBA::SystemException)`[virtual]`

| Return the authentication methods supported by the given mechanism.

void TAO_PrincipalAuthenticator::register_vault | ( | SecurityReplaceable::Vault_ptr vault | ACE_ENV_ARG_DECL | ) |

| Note: This is a TAO-specific extension.

## Member Data Documentation

int TAO_PrincipalAuthenticator::_tao_class_id = 0`[static]`

| Reimplemented from CORBA_Object.

TAO_SecurityManager* TAO_PrincipalAuthenticator::security_manager_`[private]`

| Pointer to the SecurityManager that "owns" this PrincipalAuthenticator.

ACE_Array_Base<void *> TAO_PrincipalAuthenticator::vaults_`[private]`

| Array of registered security mechanism-specific Vaults.

The documentation for this class was generated from the following files:

- PrincipalAuthenticator.h
- PrincipalAuthenticator.cpp